/**************************************************************************

	nLaunch

	main.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>

#include "general.h"
#include "image.h"
#include "file.h"
#include "ini.h"
#include "option.h"

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define APP_NAME				"nLaunch Ver 0.0.4"

#define MAIN_WND_CLASS			"nLaunchWndClass"			/* EBhẼNX */
#define WINDOW_TITLE			"nLaunch"					/* EBhẼ^Cg */

#define BUF_SIZE				256							/* obt@TCY */

#define HKEY_ID					0x5FFF						/* ֈړzbgL[ */
#define HKEY_ID_BACK			0x6FFF						/* OֈړzbgL[ */

#define TRAY_ID					1							/* ^XNgCID */
#define WM_TRAY_NOTIFY			(WM_APP + 100)				/* ^XNgCbZ[W */

#define ID_NEXT_TIMER			1							/* ֈړ̕` */
#define ID_BACK_TIMER			2							/* Oֈړ̕` */
#define TIMER_INTERVAL			1							/* `Ԋu */

#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL			0x020A						/* zC[bZ[W */
#endif


/**************************************************************************
	Global Variables
**************************************************************************/

static HMENU hTrayMenu;
static HICON hTrayIcon;
static HRGN hRgn;
static char ini_path[BUF_SIZE];
/* ` */
static PAINTINFO PaintInfo;
/* t@CXg */
static FILELIST *FileList;
static int FileListCnt;

HINSTANCE hInst;
char app_path[BUF_SIZE];

/* INI */
extern char launch_path[BUF_SIZE];
extern char filterPtn[BUF_SIZE];
extern int filterType;
extern int ShowDir;

extern int ShowModKey;
extern char ShowVKey;
extern int BackModKey;
extern char BackVKey;

extern int MoveTop;
extern int UseMouse;
extern int FindChar;
extern int LeftPos;
extern int TopPos;

extern int MoveSpeed;

extern int Layerer;
extern int LayererAlpha;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static void _SetForegroundWindow(const HWND hWnd);
static BOOL SetWindowLayerer(const HWND hWnd, const int use, const int alpha);
static void FileExecute(const char *path, const char *fname);
static char *GetTitle(const int i);
static BOOL TrayMessage(const HWND hWnd, const DWORD dwMessage, const UINT uID, const HICON hIcon, const char *pszTip);
static void SetTrayIcon(const HWND hWnd, const HICON hIcon, const char *buf);
static void SetHotKey(const HWND hWnd);
static void UnSetHotKey(const HWND hWnd);
static BOOL InitWindow(const HWND hWnd);
static void SetWindowSize(const HWND hWnd);
static void EndWindow(const HWND hWnd);
static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
static BOOL InitApplication(const HINSTANCE hInstance);
static HWND InitInstance(const HINSTANCE hInstance);


/******************************************************************************

	_SetForegroundWindow

	EBhEANeBuɂ

******************************************************************************/

static void _SetForegroundWindow(const HWND hWnd)
{
#ifndef SPI_GETFOREGROUNDLOCKTIMEOUT
#define SPI_GETFOREGROUNDLOCKTIMEOUT        0x2000
#endif
#ifndef SPI_SETFOREGROUNDLOCKTIMEOUT
#define SPI_SETFOREGROUNDLOCKTIMEOUT        0x2001
#endif
	int param;

	SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, &param, 0);
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, 0, 0);
	SetForegroundWindow(hWnd);
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (PVOID)param, 0);
}


/******************************************************************************

	SetWindowLayerer

	EBhE𔼓ɂ (Windows2000`)

******************************************************************************/

static BOOL SetWindowLayerer(const HWND hWnd, const int use, const int alpha)
{
#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED           0x00080000
#endif
#ifndef LWA_COLORKEY
#define LWA_COLORKEY            0x00000001
#endif
#ifndef LWA_ALPHA
#define LWA_ALPHA               0x00000002
#endif
	HANDLE user32_lib;
	FARPROC SetLayeredWindowAttributes;
	long lStyle;

	if(use == 0){
		//
		lStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
		lStyle &= ~WS_EX_LAYERED;
		SetWindowLong(hWnd, GWL_EXSTYLE, lStyle);
		return TRUE;
	}
	//ݒ
	user32_lib = LoadLibrary("user32.dll");
	if(user32_lib == NULL){
		return FALSE;
	}
	SetLayeredWindowAttributes = GetProcAddress(user32_lib, "SetLayeredWindowAttributes");
	if(SetLayeredWindowAttributes == NULL){ 
		FreeLibrary(user32_lib);
		return FALSE;
	}
	//EBhE̊gX^Cݒ
	lStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
	lStyle |= WS_EX_LAYERED;
	SetWindowLong(hWnd, GWL_EXSTYLE, lStyle);
	//EBhE𔼓ɂ
	SetLayeredWindowAttributes(hWnd, 0, alpha, LWA_ALPHA);
	FreeLibrary(user32_lib);
	return TRUE;
}


/******************************************************************************

	FileExecute

	t@Cs

******************************************************************************/

static void FileExecute(const char *path, const char *fname)
{
	SHELLEXECUTEINFO sei;
	char *buf;

	buf = (char *)LocalAlloc(LMEM_FIXED, lstrlen(path) + lstrlen(fname) + 2);
	if(buf == NULL){
		return;
	}
	wsprintf(buf, "%s\\%s", path, fname);

	ZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));
	sei.cbSize = sizeof(SHELLEXECUTEINFO);
	sei.fMask = 0;
	sei.hwnd = NULL;
	sei.lpVerb = NULL;
	sei.lpFile = buf;
	sei.lpParameters = NULL;
	sei.lpDirectory = path;
	sei.hInstApp = hInst;
	sei.nShow = SW_SHOWNORMAL;
	/* N */
	ShellExecuteEx(&sei);

	LocalFree(buf);
}


/******************************************************************************

	GetTitle

	t@C^Cg擾

******************************************************************************/

static char *GetTitle(const int i)
{
	static char buf[BUF_SIZE];
	char *p, *r;

	/* LZACR */
	if(i == 0 || (FileList + i)->FileName == NULL){
		return "LZ";
	}

	/* gq̏ */
	lstrcpy(buf, (FileList + i)->FileName);
	for(r = p = buf; *p != '\0'; p++){
		if(IsDBCSLeadByte(*p) == TRUE){
			p++;
			continue;
		}
		if(*p == '.'){
			r = p;
		}
	}
	*r = '\0';
	return ((*buf != '\0') ? buf : (FileList + i)->FileName);
}


/******************************************************************************

	TrayMessage

	^XNgC̃ACR̐ݒ

******************************************************************************/

static BOOL TrayMessage(const HWND hWnd, const DWORD dwMessage, const UINT uID, const HICON hIcon, const char *pszTip)
{
	NOTIFYICONDATA tnd;

	tnd.cbSize = sizeof(NOTIFYICONDATA);
	tnd.hWnd = hWnd;
	tnd.uID	= uID;
	tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage = WM_TRAY_NOTIFY;
	tnd.hIcon = hIcon;
	lstrcpy(tnd.szTip, (pszTip == NULL) ? "\0" : pszTip);
	return Shell_NotifyIcon(dwMessage, &tnd);
}


/******************************************************************************

	SetTrayIcon

	^XNgCɃACRݒ肷

******************************************************************************/

static void SetTrayIcon(const HWND hWnd, const HICON hIcon, const char *buf)
{
	if(TrayMessage(hWnd, NIM_MODIFY, TRAY_ID, hIcon, buf) == FALSE){
		/* ύXłȂꍇ͒ǉs */
		TrayMessage(hWnd, NIM_ADD, TRAY_ID, hIcon, buf);
	}
}


/******************************************************************************

	SetHotKey

	zbgL[ݒ肷

******************************************************************************/

static void SetHotKey(const HWND hWnd)
{
	/* zbgL[̓o^ */
	if(RegisterHotKey(hWnd, HKEY_ID, ShowModKey, ShowVKey) == FALSE){
		MessageBox(hWnd,
			"\"ֈړ\" ̃zbgL[ݒɎs܂", WINDOW_TITLE, MB_ICONERROR);
	}
	if(RegisterHotKey(hWnd, HKEY_ID_BACK, BackModKey, BackVKey) == FALSE){
		MessageBox(hWnd,
			"\"Oֈړ\" ̃zbgL[ݒɎs܂", WINDOW_TITLE, MB_ICONERROR);
	}
}


/******************************************************************************

	UnSetHotKey

	zbgL[

******************************************************************************/

static void UnSetHotKey(const HWND hWnd)
{
	/* zbgL[̉ */
	UnregisterHotKey(hWnd, HKEY_ID);
	UnregisterHotKey(hWnd, HKEY_ID_BACK);
}


/******************************************************************************

	InitWindow

	EBhȄ

******************************************************************************/

static BOOL InitWindow(const HWND hWnd)
{
	wsprintf(ini_path, "%s\\nLaunch.ini", app_path);

	/* INIt@Cǂݍ */
	GetOptionIni(ini_path);
	GetWindowIni(ini_path, &PaintInfo);

	/* tH_ݒ肳ĂȂꍇ͐ݒʂo */
	if(*launch_path == '\0'){
		if(SetOption(NULL, &PaintInfo) == FALSE){
			return FALSE;
		}
	}

	/* t@Cꗗ̐ݒ */
	FileListCnt = CreateFileList(launch_path, filterPtn, filterType, ShowDir, &FileList, 0);
	/* t@Cꗗ̕т𕜌 */
	RestoreFileList(app_path, FileList, FileListCnt);
	/* C[WXg̐ݒ */
	SetImegeListIcon(launch_path, FileList, FileListCnt, PaintInfo.IconSize, &PaintInfo);

	/* plrbg}bv̍쐬 */
	InitPanel(&PaintInfo);

	/* EBhËʒuTCY̐ݒ */
	SetWindowSize(hWnd);

	/* zbg[L̓o^ */
	SetHotKey(hWnd);

	/* ̐ݒ */
	SetWindowLayerer(hWnd, Layerer, LayererAlpha);

	/* ^XNgCɃACR̓o^ */
	hTrayIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON_MAIN), IMAGE_ICON, 16, 16, 0);
	SetTrayIcon(hWnd, hTrayIcon, WINDOW_TITLE);
	return TRUE;
}


/******************************************************************************

	SetWindowSize

	EBhËʒuƃTCYݒ肷

******************************************************************************/

static void SetWindowSize(const HWND hWnd)
{
	int Width;
	int Height;
	int FrameWidth = 0;
	int FrameHeight = 0;

	/* ꎞIɃTCYύX */
	SetWindowPos(hWnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW | SWP_NOZORDER | SWP_NOMOVE);
	if(PaintInfo.FlatWindow == 0){
		SetWindowLong(hWnd, GWL_STYLE, WS_POPUP | WS_DLGFRAME);
		FrameWidth = GetSystemMetrics(SM_CXDLGFRAME);
		FrameHeight = GetSystemMetrics(SM_CYDLGFRAME);
	}else{
		SetWindowLong(hWnd, GWL_STYLE, WS_POPUP);
	}

	/* EBhETCY̌vZ */
	Width = PaintInfo.WindowWidth + PaintInfo.FrameSize * 2 + FrameWidth * 2;
	Height = PaintInfo.WindowHeight + GetTitleSize(&PaintInfo) * PaintInfo.ShowTitle +
		PaintInfo.FrameSize * 2 + FrameHeight * 2;

	/* ʒǔvZ */
	LeftPos = (UseMouse == 0) ? ((GetSystemMetrics(SM_CXSCREEN) / 2) - (Width / 2)) : LeftPos;
	TopPos = (UseMouse == 0) ? ((GetSystemMetrics(SM_CYSCREEN) / 2) - (Height / 2)) : TopPos;

	/* ʒuATCY̐ݒ */
	SetWindowPos(hWnd, HWND_TOPMOST, LeftPos, TopPos, Width, Height, SWP_HIDEWINDOW);

	if(hRgn != NULL){
		DeleteObject(hRgn);
		hRgn = NULL;
	}
	if(PaintInfo.TransparentWindow == 1){
		/* wî݂̃rbg}bv쐬 */
		SetWindowText(hWnd, "");
		SetIconPanel(hWnd, &PaintInfo, NULL, -1, 0);

		/* rbg}bv烊[W쐬 */
		SelectObject(PaintInfo.hPanelDC, PaintInfo.hRetPanelBmp);
		hRgn = CreateBmpRgn(PaintInfo.hPanelBmp, PaintInfo.TransparentColor, FrameWidth, FrameHeight);
		SelectObject(PaintInfo.hPanelDC, PaintInfo.hPanelBmp);

	}
	/* EBhĚ`ݒ */
	SetWindowRgn(hWnd, hRgn, FALSE);
}


/******************************************************************************

	EndWindow

	EBhȄI

******************************************************************************/

static void EndWindow(const HWND hWnd)
{
	/* INIt@Cɏ */
	PutOptionIni(ini_path);
	PutWindowIni(ini_path, &PaintInfo);

	if(MoveTop == 1){
		/* t@Cꗗ̕тۑ */
		SaveFileList(app_path, FileList, FileListCnt);
	}

	/* t@Cꗗ̉ */
	FreeFileList(FileList, FileListCnt);
	FileList = NULL;
	FileListCnt = 0;

	UnSetHotKey(hWnd);
	TrayMessage(hWnd, NIM_DELETE, TRAY_ID, NULL, NULL);
	EndImegeListIcon();
	DestroyIcon(hTrayIcon);
	if(hRgn != NULL){
		DeleteObject(hRgn);
		hRgn = NULL;
	}
}


/******************************************************************************

	WndProc

	CEBhEvV[W

******************************************************************************/

static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static int ViewIndex;
	static int ViewPos;

	switch(msg)
	{
	case WM_CREATE:
		if(InitWindow(hWnd) == FALSE){
			DestroyWindow(hWnd);
		}
		break;

	case WM_CLOSE:
		EndWindow(hWnd);
		EndPanel(&PaintInfo);
		DestroyWindow(hWnd);
		break;

	case WM_ENDSESSION:
		SendMessage(hWnd, WM_CLOSE, 0, 0);
		return 0;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_EXITSIZEMOVE:
		{
			RECT rect;

			GetWindowRect(hWnd, &rect);
			LeftPos = rect.left;
			TopPos = rect.top;
		}
		break;

	case WM_ACTIVATE:
		if(LOWORD(wParam) == WA_INACTIVE){
			/* EBhE\ */
			ShowWindow(hWnd, SW_HIDE);
		}
		break;

	case WM_LBUTTONDOWN:
		if(UseMouse == 1){
			int i;
			/* ^Cgo[Ă鎞̂ݗL */
			if(PaintInfo.ShowTitle == 1 &&
				((i = PanelHitTest(&PaintInfo, LOWORD(lParam), HIWORD(lParam), 0)) == POS_TITLEBAR ||
				i == POS_TITLETEXT)){
				/* EBhËړJn */
				SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, lParam);
			}
			break;
		}
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
		/* EBhE\ */
		ShowWindow(hWnd, SW_HIDE);
		break;

	case WM_LBUTTONDBLCLK:
		if(UseMouse == 1){
			/* _uNbNꂽꏊ擾 */
			int i = PanelHitTest(&PaintInfo, LOWORD(lParam), HIWORD(lParam), ViewIndex);
			if(i >= POS_ICONINDEX || i == POS_SELICON){
				if(i >= POS_ICONINDEX) ViewIndex = i - POS_ICONINDEX;
				SendMessage(hWnd, WM_KEYUP, VK_RETURN, 0);
			}
		}
		break;

	case WM_NCLBUTTONDOWN:
		if(wParam == HTCAPTION){
			return DefWindowProc(hWnd, msg, wParam, lParam);
		}
	case WM_NCMBUTTONDOWN:
	case WM_NCRBUTTONDOWN:
		/* EBhE\ */
		ShowWindow(hWnd, SW_HIDE);
		break;

	case WM_KEYUP:
	case WM_SYSKEYUP:
		if(IsWindowVisible(hWnd) == TRUE &&
			(((ShowModKey & 1) && wParam == VK_MENU) ||
			((ShowModKey & 2) && wParam == VK_CONTROL) ||
			((ShowModKey & 4) && wParam == VK_SHIFT) ||
			wParam == VK_RETURN)){

			/* EBhE\ɂ */
			ShowWindow(hWnd, SW_HIDE);
			SetTrayIcon(hWnd, hTrayIcon, WINDOW_TITLE);

			if(ViewIndex == 0 || (FileList + ViewIndex)->FileName == NULL) break;
			/* s */
			FileExecute(launch_path, (FileList + ViewIndex)->FileName);
			if(MoveTop == 1){
				MoveFileList(FileList, 1, ViewIndex);
			}
			break;
		}
		if(FindChar != 0){
			break;
		}

	case WM_KEYDOWN:
	case WM_SYSKEYDOWN:
		if(wParam != (WPARAM)ShowVKey &&
			wParam != (WPARAM)BackVKey &&
			wParam != VK_MENU &&
			wParam != VK_CONTROL &&
			wParam != VK_SHIFT &&
			wParam != VK_RETURN){
			int ret;
			HKL layout;
			BYTE State[256];
			WORD result;

			if(FindChar == 0){
				/* EBhE\ */
				ShowWindow(hWnd, SW_HIDE);
				break;
			}
			/* L[𕶎ɕϊ */
			layout = GetKeyboardLayout(0);
			if(GetKeyboardState(State) == FALSE) break;
			ToAsciiEx(wParam, 0, State, &result, 0, layout);
			if((char)result < 0x21 || (char)result > 0x7E){
				ShowWindow(hWnd, SW_HIDE);
				break;
			}
			/* t@C̃CfbNX */
			ret = FindFileList(FileList, FileListCnt, ViewIndex, (char)result);
			if(ret != -1){
				/* ړ */
				ViewIndex = ret;
				ViewPos = 0;
				SetWindowText(hWnd, GetTitle(ViewIndex));
				SetIconPanel(hWnd, &PaintInfo, FileList, ViewIndex, ViewPos);
				InvalidateRect(hWnd, NULL, FALSE);
				UpdateWindow(hWnd);
			}
		}
		break;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;

			hdc = BeginPaint(hWnd, &ps);
			/* Kvȕ̕`s */
			BitBlt(hdc, ps.rcPaint.left, ps.rcPaint.top, ps.rcPaint.right, ps.rcPaint.bottom,
				PaintInfo.hPanelDC, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY);
			EndPaint(hWnd, &ps);
		}
		break;

	case WM_TIMER:
		switch(wParam)
		{
		/* ֈړ */
		case ID_NEXT_TIMER:
			ViewPos -= MoveSpeed;
			if(ViewPos <= 0){
				KillTimer(hWnd, wParam);
				ViewPos = 0;
			}
			break;

		/* Oֈړ */
		case ID_BACK_TIMER:
			ViewPos += MoveSpeed;
			if(ViewPos >= 0){
				KillTimer(hWnd, wParam);
				ViewPos = 0;
			}
			break;
		}
		/* pl̐ݒ */
		SetIconPanel(hWnd, &PaintInfo, FileList, ViewIndex, ViewPos);
		InvalidateRect(hWnd, NULL, FALSE);
		UpdateWindow(hWnd);
		break;

	case WM_HOTKEY:
		if(IsWindowVisible(hWnd) == FALSE){
			/* EBhE\ */
			ViewIndex = 0;
			ViewPos = 0;
			/* pl̐ݒ */
			SetWindowText(hWnd, GetTitle(ViewIndex));
			SetIconPanel(hWnd, &PaintInfo, FileList, ViewIndex, ViewPos);
			/* EBhE̕\ */
			ShowWindow(hWnd, SW_SHOW);

		}else{
			/* ړ͎̈ړsȂ */
			if(ViewPos != 0){
				break;
			}
			switch(wParam)
			{
			/* ֈړ */
			case HKEY_ID:
				ViewIndex++;
				if(ViewIndex >= FileListCnt){
					ViewIndex = 0;
				}
				ViewPos = PaintInfo.IconWidth - MoveSpeed;
				if(ViewPos <= 0){
					ViewPos = 0;
				}else{
					SetTimer(hWnd, ID_NEXT_TIMER, TIMER_INTERVAL, NULL);
				}
				break;

			/* Oֈړ */
			case HKEY_ID_BACK:
				ViewIndex--;
				if(ViewIndex < 0){
					ViewIndex = FileListCnt - 1;
				}
				ViewPos = PaintInfo.IconWidth * -1 + MoveSpeed;
				if(ViewPos >= 0){
					ViewPos = 0;
				}else{
					SetTimer(hWnd, ID_BACK_TIMER, TIMER_INTERVAL, NULL);
				}
				break;
			}
			/* pl̐ݒ */
			SetWindowText(hWnd, GetTitle(ViewIndex));
			SetIconPanel(hWnd, &PaintInfo, FileList, ViewIndex, ViewPos);
		}
		InvalidateRect(hWnd, NULL, FALSE);
		UpdateWindow(hWnd);

		_SetForegroundWindow(hWnd);
		if(GetForegroundWindow() != hWnd){
			/* EBhE\ */
			ShowWindow(hWnd, SW_HIDE);
		}
		break;

	case WM_MOUSEWHEEL:
		if((short)HIWORD(wParam) > 0){
			SendMessage(hWnd, WM_HOTKEY, HKEY_ID_BACK, 0);
		}else{
			SendMessage(hWnd, WM_HOTKEY, HKEY_ID, 0);
		}
		break;

	case WM_TRAY_NOTIFY:
		switch(lParam)
		{
		case WM_LBUTTONDBLCLK:
			SendMessage(hWnd, WM_COMMAND, ID_MENUITEM_OPTION, 0);
			break;

		case WM_RBUTTONUP:
			{
				POINT apos;		/* }EẌʒu */

				_SetForegroundWindow(hWnd);
				GetCursorPos((LPPOINT)&apos);
				/* |bvAbvj[\ */
				TrackPopupMenu(GetSubMenu(hTrayMenu, 0),
					TPM_TOPALIGN | TPM_RIGHTBUTTON | TPM_LEFTBUTTON,
					apos.x, apos.y, 0, hWnd, NULL);
				PostMessage(hWnd, WM_NULL, 0, 0);
			}
			break;
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case ID_MENUITEM_OPTION:
			{
				HWND fWnd;

				/* ɃIvVʂ\Ăꍇ̓ANeBuɂ */
				if((fWnd = FindWindow(NULL, OPTION_TITLE)) != NULL){
					_SetForegroundWindow(fWnd);
					break;
				}
			}
			UnSetHotKey(hWnd);
			/* ݒʂ̕\ */
			if(SetOption(NULL, &PaintInfo) == TRUE){
				SendMessage(hWnd, WM_COMMAND, ID_MENUITEM_REFRESH, 0);
			}else{
				/* pl̐ݒ */
				EndPanel(&PaintInfo);
				InitPanel(&PaintInfo);
				SetImegeListIcon(launch_path, FileList, FileListCnt, PaintInfo.IconSize, &PaintInfo);
			}
			SetHotKey(hWnd);
			break;

		case ID_MENUITEM_REFRESH:
			/* pl̐ݒ */
			EndPanel(&PaintInfo);
			InitPanel(&PaintInfo);
			/* ̐ݒ */
			SetWindowLayerer(hWnd, Layerer, LayererAlpha);
			/* EBhËʒuTCY̐ݒ */
			SetWindowSize(hWnd);

			if(MoveTop == 1){
				/* t@Cꗗ̕тۑ */
				SaveFileList(app_path, FileList, FileListCnt);
			}
			/* t@Cꗗ̐ݒ */
			FileListCnt = CreateFileList(launch_path, filterPtn, filterType, ShowDir,
				&FileList, FileListCnt);
			RestoreFileList(app_path, FileList, FileListCnt);
			SetImegeListIcon(launch_path, FileList, FileListCnt, PaintInfo.IconSize, &PaintInfo);
			break;

		case ID_MENUITEM_ABOUT:
			/* o[W */
			MessageBox(hWnd,
				APP_NAME
				"\nCopyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.\n\n"
				"HOME PAGE: http://www.nakka.com/\nE-MAIL: nakka@nakka.com",
				"About", MB_OK | MB_ICONINFORMATION);
			break;

		case ID_MENUITEM_CLOSE:
			/* EBhE */
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}


/******************************************************************************

	InitApplication

	EBhENX̓o^

******************************************************************************/

static BOOL InitApplication(const HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style = CS_DBLCLKS;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);		/* J[\ */
	wc.lpszMenuName = NULL;
	wc.lpfnWndProc = (WNDPROC)WndProc;				/* EBhEvV[W */
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = NULL;
	wc.hbrBackground = (HBRUSH)COLOR_WINDOW;
	wc.lpszClassName = MAIN_WND_CLASS;

	/* EBhENX̓o^ */
	return RegisterClass(&wc);
}


/******************************************************************************

	InitInstance

	EBhE̍쐬

******************************************************************************/

static HWND InitInstance(const HINSTANCE hInstance)
{
	HWND hWnd;

	/* EBhE̍쐬 */
	hWnd = CreateWindowEx(WS_EX_TOOLWINDOW,
		MAIN_WND_CLASS,
		WINDOW_TITLE,
		WS_POPUP,
		0, 0, 0, 0,
		NULL, NULL, hInstance, NULL);

	return hWnd;
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	hInst = hInstance;

	/* 2dNh~ */
	if(FindWindow(MAIN_WND_CLASS, NULL) != NULL){
		return 0;
	}

	/* AvP[ṼpX擾 */
	GetModuleFileName(hInstance, app_path, BUF_SIZE - 1);
	GetDirectory(app_path);

	/* EBhENX̓o^ */
	if(InitApplication(hInstance) == FALSE){
		return 0;
	}
	/* EBhE̍쐬 */
	if(InitInstance(hInstance) == NULL){
		return 0;
	}

	/* ^XNgC̃j[ */
	hTrayMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_TRAY));

	/* EBhEbZ[W */
	while(GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	DestroyMenu(hTrayMenu);
	return msg.wParam;
}

#ifndef _DEBUG
void __cdecl WinMainCRTStartup(void)
{
	int ret;

	/* WinMaiňĂяo */
	ret = WinMain(GetModuleHandle(NULL), NULL, NULL, 0);
	/* vZX̏I */
	ExitProcess(ret);
}
#endif
/* End of source */
